/**********************************************/
/* mpi_aux.c:                                 */
/* Copyright (C) 2003 Tomonori Kouya          */
/*                                            */
/* Version 0.0: 2003.10/04                    */
/*                                            */
/* This library is free software; you can re- */
/* distribute it and/or modify it under the   */
/* terms of the GNU Lesser General Public     */
/* License as published by the Free Software  */
/* Foundation; either version 2.1 of the      */
/* License, or (at your option) any later     */
/* version.                                   */
/*                                            */
/* This library is distributed in the hope    */
/* that it will be useful, but WITHOUT ANY    */
/* WARRANTY; without even the implied         */
/* warranty of MERCHANTABILITY or FITNESS FOR */
/* A PARTICULAR PURPOSE.  See the GNU Lesser  */
/* General Public License for more details.   */
/**********************************************/
#include <stdio.h>
#include <math.h>

#include "mpi.h"
#include "bnc.h"

#ifdef USE_GMP
#include "mpi_gmp.h"
#endif

#include "mpi_bnc.h"

/* set precition and default rounding mode */
#ifdef USE_GMP
void _mpi_set_bnc_default_prec(unsigned long prec, MPI_Comm comm)
{
	int myrank, num_procs;

	MPI_Comm_size(comm, &num_procs);
	MPI_Comm_rank(comm, &myrank);

	_set_bnc_default_prec(prec);
	if(myrank == 0) set_bnc_default_prec(prec);
}
void _mpi_set_bnc_default_prec_decimal(unsigned long prec, MPI_Comm comm)
{
	int myrank, num_procs;

	MPI_Comm_size(comm, &num_procs);
	MPI_Comm_rank(comm, &myrank);

	_set_bnc_default_prec_decimal(prec);
	if(myrank == 0) set_bnc_default_prec_decimal(prec);
}
#ifdef USE_MPFR
void _mpi_set_bnc_rounding_mode(mp_rnd_t rmode, MPI_Comm comm)
{
	int myrank, num_procs;

	MPI_Comm_size(comm, &num_procs);
	MPI_Comm_rank(comm, &myrank);

	_set_bnc_rounding_mode(rmode);
	if(myrank == 0) set_bnc_rounding_mode(rmode);
}
#endif
#endif
